from types import CodeType
from typing import Any, Dict, List, Optional, Tuple

class Aggregation:
    function_id: str
    total_time: int
    total_calls: int
    total_squared_time: int
    exceptions: Dict[str, int]
    callers: Tuple[CodeType]
    flow_id: Optional[str]
    sketch_data: SketchData
    code_obj: CodeType

class SketchData:
    data: List[int]
    index_shift: int
    bin_width: float

    def __init__(self, bin_width: float) -> None: ...
    def add(self, value: float) -> None: ...

class Monitor:
    def __init__(self, function_id: str) -> None: ...
    def __enter__(self) -> None: ...
    def __exit__(self, exc_type: Any, exc_value: Any, traceback: Any) -> None: ...

def get_and_swap_aggregations() -> Dict[str, Aggregation]: ...
def check_wrapped_code(code: CodeType) -> bool: ...
def check_linked_code(code: CodeType) -> bool: ...
def mark_linked_code(code: CodeType) -> bool: ...

# get_time is not time since epoch, should only be used for relative time measurements
def get_time() -> int: ...
def get_hud_running_mode() -> bool: ...
def set_hud_running_mode(value: bool) -> None: ...
def set_frame_eval_hook() -> None: ...
def get_flow_id() -> Optional[str]: ...
def set_flow_id(flow_id: Optional[str]) -> None: ...
def reset_after_fork() -> None: ...
